config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :golf_games
  # get 'home/index'
  root 'home#index'
  get 'home/about'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get 'up' => 'rails/health#show', as: :rails_health_check

  # Defines the root path route ("/")
  # root "posts#index"
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/golf_game.rb
# frozen_string_literal: true

class GolfGame < ApplicationRecord
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

app/controllers/golf_games_controller.rb
# frozen_string_literal: true

class GolfGamesController < ApplicationController
  before_action :set_golf_game, only: %i[show edit update destroy]

  # GET /golf_games or /golf_games.json
  def index
    @golf_games = GolfGame.all
  end

  # GET /golf_games/1 or /golf_games/1.json
  def show; end

  # GET /golf_games/new
  def new
    @golf_game = GolfGame.new
  end

  # GET /golf_games/1/edit
  def edit; end

  # POST /golf_games or /golf_games.json
  def create
    @golf_game = GolfGame.new(golf_game_params)

    respond_to do |format|
      if @golf_game.save
        format.html { redirect_to golf_game_url(@golf_game), notice: 'Golf game was successfully created.' }
        format.json { render :show, status: :created, location: @golf_game }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @golf_game.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /golf_games/1 or /golf_games/1.json
  def update
    respond_to do |format|
      if @golf_game.update(golf_game_params)
        format.html { redirect_to golf_game_url(@golf_game), notice: 'Golf game was successfully updated.' }
        format.json { render :show, status: :ok, location: @golf_game }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @golf_game.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /golf_games/1 or /golf_games/1.json
  def destroy
    @golf_game.destroy!

    respond_to do |format|
      format.html { redirect_to golf_games_url, notice: 'Golf game was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_golf_game
    @golf_game = GolfGame.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def golf_game_params
    params.require(:golf_game).permit(:date, :course_name, :par, :score)
  end
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end

  def about; end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/helpers/golf_games_helper.rb
# frozen_string_literal: true

module GolfGamesHelper
end

app/helpers/home_helper.rb
# frozen_string_literal: true

module HomeHelper
end

app/views/golf_games/_form.html.erb
<%= form_with(model: golf_game) do |form| %>
  <% if golf_game.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(golf_game.errors.count, "error") %> prohibited this golf_game from being saved:</h2>

      <ul>
        <% golf_game.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :date, style: "display: block" %>
    <%= form.text_field :date %>
  </div>

  <div>
    <%= form.label :course_name, style: "display: block" %>
    <%= form.text_field :course_name %>
  </div>

  <div>
    <%= form.label :par, style: "display: block" %>
    <%= form.number_field :par %>
  </div>

  <div>
    <%= form.label :score, style: "display: block" %>
    <%= form.number_field :score %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/golf_games/_golf_game.html.erb
<div id="<%= dom_id golf_game %>">
  <p>
    <strong>Date:</strong>
    <%= golf_game.date %>
  </p>

  <p>
    <strong>Course name:</strong>
    <%= golf_game.course_name %>
  </p>

  <p>
    <strong>Par:</strong>
    <%= golf_game.par %>
  </p>

  <p>
    <strong>Score:</strong>
    <%= golf_game.score %>
  </p>

</div>

app/views/golf_games/edit.html.erb
<h1>Editing golf game</h1>

<%= render "form", golf_game: @golf_game %>

<br>

<div>
  <%= link_to "Show", @golf_game %> |
  <%= link_to "Back", golf_games_path %>
</div>

app/views/golf_games/index.html.erb
<table class="table table-striped table-hover">
  <thead class="thead-dark">
    <tr>
      <th scope="col">Date</th>
      <th scope="col">Course</th>
      <th scope="col">Par</th>
      <th scope="col">Score</th>
      <th scope="col">Action</th>
    </tr>
  </thead>
  <% @golf_games.each do |golf_game| %>
    <tr>
      <td><%= golf_game.date.strftime("%Y-%m-%d") if golf_game.date %></td>
      <td><%= golf_game.course_name %></td>
      <td><%= golf_game.par %></td>
      <td><%= golf_game.score %></td>
      <td><%= link_to "Show", golf_game %>
          <%= link_to "Edit", golf_game %>
    </tr>
  <% end %>
</table>

<%= link_to "New", new_golf_game_path %>

app/views/golf_games/new.html.erb
<h1>New golf game</h1>

<%= render "form", golf_game: @golf_game %>

<br>

<div>
  <%= link_to "Back", golf_games_path %>
</div>

app/views/golf_games/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @golf_game %>

<div>
  <%= link_to "Edit", edit_golf_game_path(@golf_game) %> |
  <%= link_to "Back", golf_games_path %>

  <%= button_to "Destroy", @golf_game, method: :delete %>
</div>

app/views/home/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">
    <%= link_to "Golf Game Tracker", root_path, class:"navbar-brand" %>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <%= link_to "Home", root_path, class:"nav-link" %>
        </li>
        <li class="nav-item">
          <%= link_to "ShowGames", golf_games_path, class:"nav-link" %>
        </li>
        <li class="nav-item">
          <%= link_to "NewGame", new_golf_game_path, class:"nav-link" %>
        </li>
      </ul>
    </div>
  </div>
</nav>

app/views/home/index.html.erb
<h1>GOLF GAME TRACKER</h1>


<p>
  This project is meant to serve as a simple proof of my ability to create a CRUD web application using Rails

  Things this does:
  <ul>
    <li>Allows user to create records to track their golf game</li>
    <li>Allows user to edit and delete records from their golf game</li>
    <li>Contains CI/CD pipeline with framework for deployment. This app is not deployed but can be on request</li>
  </ul>

  Things this does not do: <br/>
  I did not implement testing. That will be done in a separate example repository.
</p>

app/views/layouts/application.html.erb
<!doctype html>
<html lang="en">
<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Bootstrap CSS -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

  <meta name="viewport" content="width=device-width,initial-scale=1">
  <%= csrf_meta_tags %>
  <%= csp_meta_tag %>

  <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  <%= javascript_importmap_tags %>

  <title>Golf Game Score Tracker</title>
</head>
<body>
  <%= render 'home/header' %>
  <div class="container">
  <br/>
  <%= yield %>
  </div>
  <!-- Optional JavaScript; choose one of the two! -->

  <!-- Option 1: Bootstrap Bundle with Popper -->
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

  <!-- Option 2: Separate Popper and Bootstrap JS -->
  <!--
  <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js" integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js" integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous"></script>
  -->
</body>
</html>